package at.bestsolution.rsd.rt.rest.apachehttp;

import java.net.URISyntaxException;
import java.nio.charset.StandardCharsets;
import java.util.function.BiConsumer;
import java.util.function.Consumer;

import org.apache.http.client.fluent.Form;
import org.apache.http.client.utils.URIBuilder;

import at.bestsolution.rsd.rt.rest.Request;

public class ApachePatchRequest extends BaseApacheRequest implements Request {

	public ApachePatchRequest(HttpExecutor httpExecutor, String endpoint) {
		super(httpExecutor, endpoint);
	}

	@Override
	protected org.apache.http.client.fluent.Request createRequest() throws URISyntaxException {
		URIBuilder builder = new URIBuilder(endpoint);
		Form form = Form.form();

		for( Consumer<BiConsumer<String,String>> param : parameters ) {
			param.accept(form::add);
		}
		
		return org.apache.http.client.fluent.Request.Patch(builder.build()).bodyForm(form.build(),StandardCharsets.UTF_8);
	}

}
