package at.bestsolution.rsd.rt.rest.apachehttp;

import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;

import at.bestsolution.rsd.rt.rest.Request;
import at.bestsolution.rsd.rt.rest.RequestFactory;

@Component
public class ApacheRequestFactory implements RequestFactory {
	private HttpExecutor httpExecutor;
	
	@Reference(cardinality = ReferenceCardinality.MANDATORY)
	public void setHttpExecutor(HttpExecutor httpExecutor) {
		this.httpExecutor = httpExecutor;
	}
	
	public void unsetHttpExecutor(HttpExecutor httpExecutor) {
		this.httpExecutor = null;
	}
	
	@Override
	public Request get(String url) {
		return new ApacheGetRequest(httpExecutor,url);
	}

	@Override
	public Request patch(String url) {
		return new ApachePatchRequest(httpExecutor,url);
	}

	@Override
	public Request post(String url) {
		return new ApachePostRequest(httpExecutor,url);
	}
	
	@Override
	public Request delete(String url) {
		return new ApacheDeleteRequest(httpExecutor,url);
	}

	@Override
	public Request patchMultipart(String url) {
		return new ApachePatchMultipartRequest(httpExecutor,url);
	}

	@Override
	public Request postMultipart(String url) {
		return new ApachePostMultipartRequest(httpExecutor,url);
	}

	@Override
	public Request put(String url) {
		return new ApachePutRequest(httpExecutor, url);
	}
}
